import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { CmsWebsiteSetting, CmsWebsiteSettingParam } from './model';

/**
 * 分页查询网站设置
 */
export async function pageCmsWebsiteSetting(params: CmsWebsiteSettingParam) {
  const res = await request.get<ApiResult<PageResult<CmsWebsiteSetting>>>(
    '/cms/cms-website-setting/page',
    {
      params
    }
  );
  if (res.code === 0) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 查询网站设置列表
 */
export async function listCmsWebsiteSetting(params?: CmsWebsiteSettingParam) {
  const res = await request.get<ApiResult<CmsWebsiteSetting[]>>(
    '/cms/cms-website-setting',
    {
      params
    }
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 添加网站设置
 */
export async function addCmsWebsiteSetting(data: CmsWebsiteSetting) {
  const res = await request.post<ApiResult<unknown>>(
    '/cms/cms-website-setting',
    data
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 修改网站设置
 */
export async function updateCmsWebsiteSetting(data: CmsWebsiteSetting) {
  const res = await request.put<ApiResult<unknown>>(
    '/cms/cms-website-setting',
    data
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 删除网站设置
 */
export async function removeCmsWebsiteSetting(id?: number) {
  const res = await request.del<ApiResult<unknown>>(
    '/cms/cms-website-setting/' + id
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 批量删除网站设置
 */
export async function removeBatchCmsWebsiteSetting(data: (number | undefined)[]) {
  const res = await request.del<ApiResult<unknown>>(
    '/cms/cms-website-setting/batch',
    {
      data
    }
  );
  if (res.code === 0) {
    return res.message;
  }
  return Promise.reject(new Error(res.message));
}

/**
 * 根据id查询网站设置
 */
export async function getCmsWebsiteSetting(id: number) {
  const res = await request.get<ApiResult<CmsWebsiteSetting>>(
    '/cms/cms-website-setting/' + id
  );
  if (res.code === 0 && res.data) {
    return res.data;
  }
  return Promise.reject(new Error(res.message));
}
